Subject: Re: Trust Packets

From: [email-masked] (Peter Gutmann)
Date: Thu, 5 Feb 2004 03:28:43 +1300

Simon Josefsson <[email-masked]> writes:
>[email-masked] (Peter Gutmann) writes:
>> I've thought about this a bit in the past (I use databases to store
>> other types of keys) but because of the free-form association of
>> different bits and pieces of keys with identifying information I
>> can't think of any easy way to do it unless you use a multi-level
>> lookup.  That is, you can't do a:
>>
>>   SELECT key FROM table WHERE email = foo
>>
>> because there could be an arbitrary number of email addresses attached to a
>> key, and there could be an arbitrary number of keys associated with an email
>> address.  So you need something like:
>>
>>   SELECT keyID FROM indexTable WHERE email = foo
>>   SELECT key FROM sigKeyTable WHERE keyID = foo
>>
>> which isn't very efficient (multiple tables, multi-level lookups, etc etc).
>
>Have you tried this and found that performance is the most performance
>critical area?  

I hadn't really checked it, because the code could end up plugged into almost
any database type (via ODBC) on any kind of system, I wasn't sure that results
for one particular environment would be terribly useful.  For example if you
can tell the back-end (via SQL hinting) to use a hashed index held in RAM it'd
be pretty quick. If you end up with a linear scan on disk, it'd be pretty
awful.

>(The database contained the equivalent of ~2GB PGP keyrings worth of data,
>although the machine had enough memory to store the entire database in RAM.)

Yeah, well that would help a bit :-).

Peter.

---

From: Simon Josefsson <[email-masked]>
Date: Wed, 04 Feb 2004 16:48:42 +0100

> Yeah, well that would help a bit :-).

I guess.  But it was the largest OpenPGP key database I could find; a
snapshot of the key ring from some global PGP key database (100 ~22GB
files, dated from 2002 or so -- if this sounds like it might have been
truncated I'd appreciate being informed).  So even if I agree the
database is small by todays RAM size standards, I don't believe it was
a toy database, so the data point can't be that irrelevant.  And I'd
also imagine someone building a serious production server have more
memory in their servers than a modern desktop PC like mine.  (For
reference, my database was PostgreSQL, I didn't apply any performance
tweaks.)

What we need is a way to embed those MPEG files in OpenPGP keys. :-)

Regards,
Simon

---

From: David Shaw <[email-masked]>
Date: Thu, 5 Feb 2004 11:25:36 -0500

> What we need is a way to embed those MPEG files in OpenPGP keys. :-)

I can just see it: a "movie" attribute.  "Hi!  I'm David, and my
fingerprint is...."

David

---

From: Florian Weimer <[email-masked]>
Date: Thu, 5 Feb 2004 23:05:09 +0100

David Shaw wrote:

> I can just see it: a "movie" attribute.

It's called "logotype" and X.509 has it. 8-)